
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <NDS.h>

#include "_console.h"
#include "_consolewritelog.h"
#include "maindef.h"
#include "memtool.h"
#include "_const.h"
#include "shell.h"
#include "strtool.h"

#include "lang.h"
#include "ErrorDialog.h"
#include "glib/glib.h"
#include "skin.h"

static bool isExists;
static EErrorCode ErrorCode;

void ErrorDialog_Init(void)
{
  isExists=false;
  return;
  
  // for test
  isExists=true;
  ErrorCode=(EErrorCode)2;
}

void ErrorDialog_Clear(void)
{
  isExists=false;
}

bool ErrorDialog_isExists(void)
{
  return(isExists);
}

void ErrorDialog_Set(EErrorCode _ErrorCode)
{
  if(isExists==true) return;
  isExists=true;
  ErrorCode=_ErrorCode;
}

void ErrorDialog_Draw(CglCanvas *pcan)
{
  CglTGF* perrdlgbg=Skin_GetErrorDialogBG();
  if(perrdlgbg==NULL){
    _consolePrintf("ErrorDialog_Draw: Can not load ErrorDialogBG.\n");
    ShowLogHalt();
  }
  
  u32 w=perrdlgbg->GetWidth(),h=perrdlgbg->GetHeight();
  u32 x=2,y=ScreenHeight-h-4;
  
  perrdlgbg->BitBlt(pcan,x,y);
  
  if(perrdlgbg!=NULL){
    delete perrdlgbg; perrdlgbg=NULL;
  }
  
  const char *perrmsg0=NULL,*perrmsg1=NULL;
  
  switch(ErrorCode){
/*
    case EEC_: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_");
      perrmsg1=Lang_GetUTF8("ERRMSG1_");
    } break;
*/
    case EEC_MemoryOverflow_CanRecovery: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_MemoryOverflow_CanRecovery");
      perrmsg1=Lang_GetUTF8("ERRMSG1_MemoryOverflow_CanRecovery");
    } break;
    case EEC_NotSupportFileFormat: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_NotSupportFileFormat");
      perrmsg1=Lang_GetUTF8("ERRMSG1_NotSupportFileFormat");
    } break;
    case EEC_ProgressiveJpeg: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_ProgressiveJpeg");
      perrmsg1=Lang_GetUTF8("ERRMSG1_ProgressiveJpeg");
    } break;
    case EEC_Text0byte: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_Text0byte");
      perrmsg1=Lang_GetUTF8("ERRMSG1_Text0byte");
    } break;
    case EEC_OverflowLargeImage: {
      perrmsg0=Lang_GetUTF8("ERRMSG0_OverflowLargeImage");
      perrmsg1=Lang_GetUTF8("ERRMSG1_OverflowLargeImage");
    } break;
    default: {
      perrmsg0="Unknown error code.";
      perrmsg1="Internal error?";
    }
  }
  
  x+=8;
  y+=24+3;
  
  pcan->SetFontTextColor(ColorTable.ErrorDialog.MessageText);
  if(perrmsg0!=NULL) pcan->TextOutUTF8(x,y+(14*0),perrmsg0);
  if(perrmsg1!=NULL) pcan->TextOutUTF8(x,y+(14*1),perrmsg1);
}

